<?
include ("/usr/local/www/include/cookie.h");
include ("/usr/local/www/include/function.h");
include ("/usr/local/www/include/htmltag.h");

$message = new MESSAGE;
$message->set_locale($locale);
$message->set_message("lan_ip_address.msg");

$form_name = "lan_ip_address";

$action = $_POST["action"];

$ip_address = $_POST["ip_address"];
$subnet_mask = $_POST["subnet_mask"];
$dhcp_lan = $_POST["dhcp_lan"];
$address_start = $_POST["address_start"];
$address_end = $_POST["address_end"];
$lease_time = $_POST["lease_time"];
$dhcp_allow = $_POST["dhcp_allow"];
$tmp_dhcp_lan = $_POST["tmp_dhcp_lan"];
$tmp_address_start = $_POST["tmp_address_start"];
$tmp_address_end = $_POST["tmp_address_end"];
$tmp_lease_time = $_POST["tmp_lease_time"];


$msg1 = $_POST["msg1"];
$msg2 = $_POST["msg2"];
$msg3 = $_POST["msg3"];
$msg4 = $_POST["msg4"];


$bin = new BIN;
$bin->set_service_type(2);
$bin->set_file_path();


$api = new CALLAPI;
$api->set_service_type("2");



if ($action == "save")
{

	if ($dhcp_allow == "0")
	{	
		$dhcp_lan = $tmp_dhcp_lan;
		$address_start = $tmp_address_start;
		$address_end = $tmp_address_end;
		$lease_time = $tmp_lease_time;	
	}
	if ($dhcp_lan == "0")
	{
		$address_start = $tmp_address_start;
		$address_end = $tmp_address_end;
		$lease_time = $tmp_lease_time;	
	}

	$api->set_msg_id("131");
	$api->set_record_size(64);
	$api->set_msg_length(64);
	$api->set_msg_type("F0");

	$value_input = NULL;
	$value_input[0] = $ip_address;
	$value_input[1] = $subnet_mask;
	$value_input[2] = $bin->num2str(dechex($dhcp_lan),1);
	$value_input[3] = $address_start;
	$value_input[4] = $address_end;
	$value_input[5] = $bin->num2str(dechex($lease_time),1);
	$value_input[6] = $bin->num2str(dechex($dhcp_allow),1);
	$value_input[7] = NULL;

	$bin->set_structure(array(15,15,1,15,15,1,1,1));
	$ret = NULL;
	$ret = $bin->set_input_value(array($value_input));
	if ($ret)
	{
		$bin->writeBin();
		$api->exec_api();
		$resp = $bin->get_response();
		if (!$resp)
		{
			$ret1 = NULL;
			$bin->set_structure(array(1,1));
			$ret1 = $bin->readBin();
			if($ret1)
			{
				$result = NULL;
				$result = $bin->get_result();
				$error_return = (int)$bin->str2num($result[0][0],1);
			}
				
			if ($error_return == 100)
			{
				$tmp_msg = $message->get_line(32); // 32 : ("LAN IP address is in conflict with WAN network! Please input again")
			}
			else
			{
				$tmp_msg = $message->get_line(27); // 27 : ("The data is not stored. Please check the input values.")
			}	
			$js_message = "alert(\"$tmp_msg\");\n";
		}
		else 
		{
				$tmp_dhcp_lan = $dhcp_lan;
				$tmp_address_start = $address_start;
				$tmp_address_end = $address_end;
				$tmp_lease_time = $lease_time;	
		}
	}
	else
	{
		$tmp_msg = $message->get_line(1); // 1 : ("Error")
		$js_message = "alert(\"$tmp_msg\")";
	}

}

if ($action == NULL || $action == "save")
{

	$api->set_msg_type("D0");
	$api->set_msg_id("131");
	$api->set_record_size (64);
	$api->set_msg_length(0);
	$api->exec_api();
	$resp = $bin->get_response();
	if ($resp)
	{
		$ret = NULL;
		$bin->set_structure(array(15,15,1,15,15,1,1,1));
		$ret = $bin->readBin();
		if($ret)
		{
			$result = NULL;
			$result = $bin->get_result();
			$ip_address = trim($result[0][0]);
			$subnet_mask = trim($result[0][1]);
			$dhcp_lan = (int)$bin->str2num($result[0][2],1);
			$address_start = trim($result[0][3]);
			$address_end = trim($result[0][4]);
			$lease_time = (int)$bin->str2num($result[0][5],1);
			$dhcp_allow = (int)$bin->str2num($result[0][6],1);

			$tmp_dhcp_lan = $dhcp_lan;
			$tmp_address_start = $address_start;
			$tmp_address_end = $address_end;
			$tmp_lease_time = $lease_time;
			
			if ($dhcp_allow == 1)
			{
				$dhcp_lan_disabled1 = NULL;
				$disabled3 = NULL;
			}	
			else if ($dhcp_allow == 0)
			{
				$dhcp_lan_disabled1 = "disabled";
				$disabled3 = "disabled";
			}	
		}
		else
		{
			$tmp_msg = $message->get_line(1); // 1 : ("Error")
			$js_message = "alert(\"$tmp_msg\")";
		}
	}
	else
	{
		$tmp_msg = $message->get_line(28); // 28 : ("Failed to read data from system. Try again.")
		$js_message = "alert(\"$tmp_msg\")";
	}
}

//if (!$action)
{
	$msg1 = $message->get_line(22); // 22 : ("Please Input &quot;IP Address&quot;")
	$msg2 = $message->get_line(23); // 23 : ("Please Input &quot;Subnet Mask&quot;")
	$msg3 = $message->get_line(24); // 24 : ("Please Input &quot;Address Range&quot;")
	$msg4 = $message->get_line(25); // 25 : ("Invalid input, please check again")
}

if ($dhcp_lan == "0")
{
		$disabled1 = "disabled";
		$disabled2 = "disabled";
}
else if ($dhcp_lan == "1")
{
		$disabled1 = NULL;
		$disabled2 = NULL;
}

create_html_head();

?>

<script language=javascript>
<!--
<?
	if ($js_message != NULL)
	{
		echo "$js_message";
	}
?>	

function <? echo ($form_name) ?>_save()
{
	var ip_adr1 = document.<? echo "$form_name" ?>.ip_address1;
	var ip_adr2 = document.<? echo "$form_name" ?>.ip_address2;
	var ip_adr3 = document.<? echo "$form_name" ?>.ip_address3;
	var ip_adr4 = document.<? echo "$form_name" ?>.ip_address4;
	var sn_msk1 = document.<? echo "$form_name" ?>.subnet_mask1;
	var sn_msk2 = document.<? echo "$form_name" ?>.subnet_mask2;
	var sn_msk3 = document.<? echo "$form_name" ?>.subnet_mask3;
	var sn_msk4 = document.<? echo "$form_name" ?>.subnet_mask4;
	var ads1 = document.<? echo "$form_name" ?>.address_start1;
	var ads2 = document.<? echo "$form_name" ?>.address_start2;
	var ads3 = document.<? echo "$form_name" ?>.address_start3;
	var ads4 = document.<? echo "$form_name" ?>.address_start4;
	var ade1 = document.<? echo "$form_name" ?>.address_end1;
	var ade2 = document.<? echo "$form_name" ?>.address_end2;
	var ade3 = document.<? echo "$form_name" ?>.address_end3;
	var ade4 = document.<? echo "$form_name" ?>.address_end4;
	var dhcp = document.<? echo "$form_name" ?>.dhcp_lan;
	var tmp_msg1 = document.<? echo "$form_name" ?>.msg1;
	var tmp_msg2 = document.<? echo "$form_name" ?>.msg2;
	var tmp_msg3 = document.<? echo "$form_name" ?>.msg3;
	var tmp_msg4 = document.<? echo "$form_name" ?>.msg4;

	for(i=1;i<5;i++)
	{
		if (eval("ip_adr"+i+".value.length") == 0)
		{
			alert(tmp_msg1.value);
			eval("ip_adr"+i+".select()");
			eval("ip_adr"+i+".focus()");
			button_click=1;
			return false;
		}
	}

	if (dhcp.value == "1")
	{
		for(i=1;i<5;i++)
		{
			if (eval("ads"+i+".value.length") == 0)
			{
				alert(tmp_msg3.value);
				eval("ads"+i+".select()");
				eval("ads"+i+".focus()");
				button_click=1;
				return false;
			}
		}
		for(i=1;i<5;i++)
		{
			if (eval("ade"+i+".value.length") == 0)
			{
				alert(tmp_msg3.value);
				eval("ade"+i+".select()");
				eval("ade"+i+".focus()");
				button_click=1;
				return false;
			}
		}	
	}

	document.<? echo "$form_name" ?>.action.value = 'save';
	document.<? echo "$form_name" ?>.submit();
}

function dhcp_configration()
{
	var ip_cfg =document.<? echo "$form_name" ?>.dhcp_lan.value;
	if (ip_cfg == 0)
	{
		document.<? echo "$form_name" ?>.address_start1.disabled = true;
		document.<? echo "$form_name" ?>.address_start2.disabled = true;
		document.<? echo "$form_name" ?>.address_start3.disabled = true;
		document.<? echo "$form_name" ?>.address_start4.disabled = true;
		document.<? echo "$form_name" ?>.address_end1.disabled = true;
		document.<? echo "$form_name" ?>.address_end2.disabled = true;
		document.<? echo "$form_name" ?>.address_end3.disabled = true;
		document.<? echo "$form_name" ?>.address_end4.disabled = true;
		document.<? echo "$form_name" ?>.lease_time.disabled = true;
	}
	else if (ip_cfg == 1)
	{
		document.<? echo "$form_name" ?>.address_start1.disabled = false;
		document.<? echo "$form_name" ?>.address_start2.disabled = false;
		document.<? echo "$form_name" ?>.address_start3.disabled = false;
		document.<? echo "$form_name" ?>.address_start4.disabled = false;
		document.<? echo "$form_name" ?>.address_end1.disabled = false;
		document.<? echo "$form_name" ?>.address_end2.disabled = false;
		document.<? echo "$form_name" ?>.address_end3.disabled = false;
		document.<? echo "$form_name" ?>.address_end4.disabled = false;
		document.<? echo "$form_name" ?>.lease_time.disabled = false;
	}	

}

-->
</script>
<?

function create_html_ip_input1 ($name, $value, $form_name, $section=NULL, $option=NULL)
{
	global $locale;
/*
	if ($locale == "de_DE") {
		$msg1 = "Falsche Eingabe! Bitte berprfen Sie Ihre Eingabe.";
		$msg2 = "Sonderzeichen im Wertefeld.";
	} else {
		$msg1 = "Invalid input, please check again.";
		$msg2 = "The special character is included in the value.";
	}
*/
	$message = new MESSAGE;
	$message->set_locale($locale);
	$message->set_message("lan_ip_address.msg");

	$msg1 = $message->get_line(25); // ("Invalid input, please check again.")
	$msg2 = $message->get_line(33); // ("The special character is included in the value.")

	$message = NULL;

	if ($name == NULL)
		return "\nname is null";

	$message = "\n";
	$message .= create_html_input ("hidden", "$name", NULL, NULL, $value, NULL);

	$message .= "\n<script language=\"JavaScript\">\n<!--\n

	var gIpCurrentIndex = 0;
	
	function js_{$form_name}_{$name}_number_check(current)
	{
//		if ( current.value != \"\" )
//			current.value = Number(current.value);
		";

		if ($section != NULL)
			$message .= "document.$form_name.$name.value = document.$form_name.{$name}1.value+\".\"+document.$form_name.{$name}2.value+\".\"+document.$form_name.{$name}3.value+\".\"+document.$form_name.{$name}4.value+\"$section\"+document.$form_name.{$name}5.value;\n";
		else
			$message .= "document.$form_name.$name.value = document.$form_name.{$name}1.value+\".\"+document.$form_name.{$name}2.value+\".\"+document.$form_name.{$name}3.value+\".\"+document.$form_name.{$name}4.value;\n";

		$message .= "\n
	}

	function js_{$form_name}_{$name}_tab_check (current, event)
	{
		if(window.event)
		{
			event = window.event;
		}
	
		if (event.keyCode == 9 || event.keyCode == 190 || event.keyCode == 110)
		{
			if (current.value.length != 0)
			{
				current.value = parseInt(current.value, 10);
				event.keyCode = 9;
				return;
			}
		}
		if ((event.keyCode >= 48 && event.keyCode <= 57) ||
			(event.keyCode >= 96 && event.keyCode <= 105) ||
			event.keyCode == 16 || event.keyCode == 8 ||
			event.keyCode == 17 || event.keyCode == 18 ||
			event.keyCode == 20 || event.keyCode == 21 ||
			event.keyCode == 25 || event.keyCode == 27 ||
			event.keyCode == 37 || event.keyCode == 39 ||
			event.keyCode == 45 || event.keyCode == 46 ||
			event.keyCode == 91 || event.keyCode == 92 )
		{
            var strCurrent = current.name;
			gIpCurrentIndex = strCurrent.substr(strCurrent.length-1, 1);
			return;
		}	

        if(window.event){
			event.returnValue = false;
		}
		else{
			event.preventDefault();
		}
	}

    function js_{$form_name}_{$name}_input_next (current, next, input_cnt, event)
    {\n";
		$message .= " var denny = /[^0-9]/;
		if (current.value.length != 0 && input_cnt == 4 && (denny.test(current.value) || current.value>254 || current.value<1))
		{
			alert (\"$msg1\");
			current.value = \"\";
			current.focus();
			current.select();
		}
		else if (current.value.length != 0 && input_cnt == 1 && (denny.test(current.value) || current.value>223 || current.value<1))
		{
			alert (\"$msg1\");
			current.value = \"\";
			current.focus();
			current.select();
		}
		else if (current.value.length != 0 && (input_cnt != 1 && input_cnt != 4) && (denny.test(current.value) || current.value>255 || current.value<0))
		{
			alert (\"$msg1\");
			current.value = \"\";
			current.focus();
			current.select();
		}\n";

	if ($section != NULL)
		$message .= "document.$form_name.$name.value = document.$form_name.{$name}1.value+\".\"+document.$form_name.{$name}2.value+\".\"+document.$form_name.{$name}3.value+\".\"+document.$form_name.{$name}4.value+\"$section\"+document.$form_name.{$name}5.value;\n";
	else
		$message .= "document.$form_name.$name.value = document.$form_name.{$name}1.value+\".\"+document.$form_name.{$name}2.value+\".\"+document.$form_name.{$name}3.value+\".\"+document.$form_name.{$name}4.value;\n";
		$message .= "
		var strCurrent = current.name;
		if(gIpCurrentIndex == strCurrent.substr(strCurrent.length-1, 1))
		{
			if (current.value.length == 3 && next != 0)
			{
				if ((event.keyCode >= 48 && event.keyCode <= 57) ||
					(event.keyCode >= 96 && event.keyCode <= 105) )
				{
					next.focus();
					next.select();
				}
			}
		}
	}\n-->\n</script>\n";
	
	if ($section != NULL) {
		//  $tmp_ip = strtok (ltrim ($value), ":\n\t");
		//  $tmp_range_ip = strtok (":\n\t");
		// 050727 pjh0347
		$tmp_ip = strtok (ltrim ($value), "$section\n\t");
		$tmp_range_ip = strtok ("$section\n\t");
		$tmp_ip = strtok (ltrim ($tmp_ip), ".\n\t");
	} else
		$tmp_ip = strtok (ltrim ($value), ".\n\t");
	for ($i=0; $i<4; $i++)
	{
		$input_cnt = $i + 1;
		$js_cnt = $i + 2;
		if ($i != 0) {
			$tmp_ip = strtok (".\n\t");
			$message .= ".";
		}
		if ($i == 3)
			$message .= create_html_input ("text", "$name$input_cnt", 3, 3, $tmp_ip, "$option onblur=\"javascript:js_{$form_name}_{$name}_number_check(this)\" onkeydown=\"javascript:js_{$form_name}_{$name}_tab_check(this, event)\" onkeyup=\"javascript:js_{$form_name}_{$name}_input_next(this, 0, $input_cnt, event)\"");
		else
			$message .= create_html_input ("text", "$name$input_cnt", 3, 3, $tmp_ip, "$option onblur=\"javascript:js_{$form_name}_{$name}_number_check(this)\" onkeydown=\"javascript:js_{$form_name}_{$name}_tab_check(this, event)\" onkeyup=\"javascript:js_{$form_name}_{$name}_input_next(this, document.$form_name.$name$js_cnt, $input_cnt, event)\"");
	}
	if ($section != NULL) {
		$input_cnt++;
		//$message .= " ~ ";
		$message .= $section;
		$message .= create_html_input ("text", "$name$input_cnt", 3, 3, $tmp_range_ip, "$option onblur=\"javascript:js_{$form_name}_{$name}_number_check(this)\" onkeydown=\"javascript:js_{$form_name}_{$name}_tab_check(this, event)\" onkeyup=\"javascript:js_{$form_name}_{$name}_input_next(this, document.$form_name.$name$js_cnt, event)\"");
	}

	return $message;
}
	

// form setting
	$form = new FORM;
	$form->set_name ("$form_name");
	$form->set_action($PHP_SELF);
	$form->add_hidden_input("action");
	$form->add_hidden_input("msg1", $msg1);
	$form->add_hidden_input("msg2", $msg2);
	$form->add_hidden_input("msg3", $msg3);
	$form->add_hidden_input("msg4", $msg4);
	$form->add_hidden_input("dhcp_allow", $dhcp_allow);
	$form->add_hidden_input("tmp_dhcp_lan", "$tmp_dhcp_lan");
	$form->add_hidden_input("tmp_address_start", $tmp_address_start);
	$form->add_hidden_input("tmp_address_end", $tmp_address_end);
	$form->add_hidden_input("tmp_lease_time", "$tmp_lease_time");

//	$l_time -> 2 : ("30 minutes"), 3 : ("1 hour"), 4 : ("2 hours"), 5 : ("12 hours"), 6 : ("24 hours")
	$l_time = array($message->get_line(2), "0", $message->get_line(3), "1", $message->get_line(4), "2", $message->get_line(5), "3", $message->get_line(6), "4");
//  $on_off -> 30 : ("Off"), 31 : ("On") 	
    $on_off = array($message->get_line(30), "0", $message->get_line(31), "1"); 	

	$space = "&nbsp;&nbsp;";
	
	$table = new TABLE;
	$table->set_title ($message->get_line(13)); // 13 : ("LAN Setting")
	$table->set_top_width(array("100%"));

	$table->set_top_contents(array($message->get_line(8)."<br>". // 8 : ("You can change the IP addresses of Samsung Router.")
	$message->get_line(29))); // 29 : ("Inappropriate settings can lead to the wrong operation of Samsung Router.")
	$table->set_top_option(0,0, "style='font-family:verdana;font-size: 11px;padding:0 10 10 10;color:#7b7a7a'");
	$table->set_top_space(1);
	$table->set_td_width(array("45%", "55%"));
	$table->add_tr_contents(array($message->get_line(7))); // 7 : ("LAN IP Address")
	$table->set_td_option(-1, 0, "align=center colspan=2");
	$table->set_td_style(-1, 0, "font-family:verdana; color:#7a7a7a; font-size: 11px;", 2);
		$tmp = create_html_ip_input1 ("ip_address", $ip_address, $form_name);
	$table->add_tr_contents(array($message->get_line(14), $tmp)); // 14 : ("IP Address")
	$table->set_td_option(-1, 0, "align=left");
	$table->set_td_style(-1, 0, NULL, 1);
	$table->set_td_option(-1, 1, "align=left");
	$table->set_td_style(-1, 1, NULL);
		$tmp = create_html_ip_input ("subnet_mask", $subnet_mask, $form_name, NULL, "readonly", "1");
	$table->add_tr_contents(array($message->get_line(15), $tmp)); // 15 : ("Subnet Mask")
	$table->set_td_option(-1, 0, "align=left");
	$table->set_td_style(-1, 0, NULL, 1);
	$table->set_td_option(-1, 1, "align=left bgcolor=#ECECEC");
	$table->set_td_style(-1, 1, NULL);

	$table1 = new TABLE;
	$table1->set_top_space(20);
	$table1->set_td_width(array("30%", "15%", "55%"));
	$table1->add_tr_contents(array($message->get_line(26))); // 26 : ("DHCP Server")
	$table1->set_td_option(-1, 0, "align=center colspan=3");
	$table1->set_td_style(-1, 0, "font-family:verdana; color:#7b7a7a; font-size: 11px;", 2);
		$tmp = create_html_select("dhcp_lan", $on_off, $dhcp_lan, "style='width:90' onchange=javascript:dhcp_configration() $dhcp_lan_disabled1", 2);
	$table1->add_tr_contents(array($message->get_line(16), $tmp)); // 16 : ("Use DHCP Server for LAN")	
	$table1->set_td_option(-1, 0, "colspan=2 align=left");
	$table1->set_td_style(-1, 0, NULL, 1);
	$table1->set_td_option(-1, 1, "align=left");
	$table1->set_td_style(-1, 1, NULL);
		$tmp1 = create_html_ip_input ("address_start", $address_start, $form_name, NULL, "$disabled1 $disabled3");
		$tmp2 = create_html_ip_input ("address_end", $address_end, $form_name, NULL, "$disabled1 $disabled3");
	$table1->add_tr_contents(array($message->get_line(17), $message->get_line(18),  $tmp1)); // 17 : ("Address Range"), 18 : ("Start")
	$table1->set_td_option(-1, 0, "rowspan=2 align=left");
	$table1->set_td_style(-1, 0, NULL, 1);
	$table1->set_td_option(-1, 1, "align=center");
	$table1->set_td_style(-1, 1, "font-family:verdana; color:#7b7a7a; font-size: 11px;", 2);
	$table1->set_td_option(-1, 2, "align=left");
	$table1->set_td_style(-1, 2, NULL);
	$table1->add_tr_contents(array($message->get_line(19),  $tmp2)); // 19 : ("End")
	$table1->set_td_option(-1, 0, "align=center");
	$table1->set_td_style(-1, 0, "font-family:verdana; color:#7b7a7a; font-size: 11px;", 2);
	$table1->set_td_option(-1, 1, "align=left");
	$table1->set_td_style(-1, 1, NULL);
		$tmp = create_html_select ("lease_time", $l_time,  $lease_time, "style='width:90' $disabled2 $dhcp_lan_disabled1", 2);
	$table1->add_tr_contents(array($message->get_line(20),  $tmp)); // 20 : ("Lease Time")
	$table1->set_td_option(-1, 0, "colspan=2 align=left");
	$table1->set_td_style(-1, 0, NULL, 1);
	$table1->set_td_option(-1, 1, "align=left");
	$table1->set_td_style(-1, 1, NULL);
		
	
	$button = new BUTTON;
	$button->set_top_space("20");
	$button->set_locale($locale);
	$button->set_button (array($message->get_line(21)), array("{$form_name}_save()")); // 21 : ("Save")

	create_form($form);
	create_top_table_head();
	create_contents_table($table);
	create_contents_table($table1);
	create_button_table($button, "right");
	create_top_table_tail();
	create_html_tail();

?>




	
	
