#!/bin/sh

HOME="/"
DIR_TMP_DB=$HOME"tmp/db_config/tmp_db"
DIR_CURRENT_DB=$HOME"configs"
UPLOAD_FILE=$HOME"tmp/upload_db/iad_config.tgz"

cd $DIR_TMP_DB

mv $UPLOAD_FILE iad_config.tgz

tar zxf iad_config.tgz
sleep 1

SUM=`md5sum db.tgz`
for i in $SUM
do
	SUM0=$i
	break
done

SUM1=`cat ./db.info`
for i in $SUM1
do
	SUM2=$i
	break
done

if [ "$SUM0" != "$SUM2" ] ; then
	echo "Invalid DB file!" > /tmp/db_config/db_status.log
	exit 2
fi

echo "checksum OK" > /tmp/db_config/db_status.log
sleep 1
exit 0

