<?
include ("/usr/local/www/include/cookie.h");
include ("/usr/local/www/include/function.h");
include ("/usr/local/www/include/htmltag.h");

$message = new MESSAGE;
$message->set_locale($locale);
$message->set_message("upnp_option.msg");

$form_name = "upnp_option";


$action = $_POST["action"];
$upnp_transfer = $_POST["upnp_transfer"];

$bin = new BIN;
$bin->set_service_type(2);
$bin->set_file_path();


$api = new CALLAPI;
$api->set_service_type("2");



if ($action == "save")
{

	$api->set_msg_id("191");
	$api->set_record_size(2);
	$api->set_msg_length(2);
	$api->set_msg_type("F0");

	$value_input = NULL;
	$value_input[0] = $bin->num2str(dechex($upnp_transfer),1);
	$value_input[1] = NULL;

	$bin->set_structure(array(1,1));
	$ret = NULL;
	$ret = $bin->set_input_value(array($value_input));
	if ($ret)
	{
		$bin->writeBin();
		$api->exec_api();
		$resp = $bin->get_response();
		if (!$resp)
		{
			$tmp_msg = $message->get_line(9); // 9 : ("The data is not stored. Please check the input values.")
			$js_message = "alert(\"$tmp_msg\");\n";
		}
	}
	else
	{
		$tmp_msg = $message->get_line(1); // 1 : ("Error")
		$js_message = "alert(\"$tmp_msg\");";
	}	
	
}

if ($action == NULL)
{

	$api->set_msg_type("D0");
	$api->set_msg_id("191");
	$api->set_record_size (2);
	$api->set_msg_length(0);
	$api->exec_api();
	$resp = $bin->get_response();
	if ($resp)
	{
		$ret = NULL;
		$bin->set_structure(array(1,1));

		$ret = $bin->readBin();
		if($ret)
		{
			$result = NULL;
			$result = $bin->get_result();
			$upnp_transfer = (int)$bin->str2num($result[0][0],1);
		}
		else
		{
			$tmp_msg = $message->get_line(1); // 1 : ("Error")
			$js_message = "alert(\"$tmp_msg\")";
		}
	}
	else
	{
		$tmp_msg = $message->get_line(10); // 10 : ("Failed to read data from system. Try again.")
		$js_message = "alert(\"$tmp_msg\")";
	}
}


create_html_head();

?>

<script language=javascript>
<!--
<?
	if ($js_message != NULL)
	{
		echo "$js_message";
	}
?>	

function <? echo ($form_name) ?>_save()
{
	document.<? echo "$form_name" ?>.action.value = 'save';
	document.<? echo "$form_name" ?>.submit();
}

-->
</script>
<?

// form setting
	$form = new FORM;
	$form->set_name ("$form_name");
	$form->set_action($PHP_SELF);
	$form->add_hidden_input("action");

    $on_off = array($message->get_line(13), "0", $message->get_line(14), "1"); // 13 : ("Off"),  14 : ("On")
    $space = "&nbsp;&nbsp;&nbsp;&nbsp;";
    $nbsp = "&nbsp;&nbsp;";	
	

	$table = new TABLE;
	$table->set_title ($message->get_line(2)); // 2 : ("UPnP Option")
	$table->set_top_space(1);
	$table->set_tr_option(0, "bgcolor=#FFFFFF");
	$table->set_td_width(array("70%", "30%"));
	$tmp = create_html_select("upnp_transfer", $on_off, $upnp_transfer, "style='width:60'", 2);
	$table->add_tr_contents(array($message->get_line(12), $tmp)); // 12 : ("Universal Plug and Play Internet Gateway Device")
	$table->set_td_option(-1, 0, "align=left");
	$table->set_td_style(-1, 0, NULL, 1);
	$table->set_td_option(-1, 1, "align=left");
	$table->set_td_style(-1, 1, NULL);
	$table->add_tr_contents(array($message->get_line(11))); // 11 : ("Through Universal Plug and Play(UPnP), the Samsung Router transfers Internet <br>connection status information for connected computers and supports the creation of short-lived dynamic port mappings from hosts on the LAN for applications such as multiplayer games, <br>Internet chat and Peer-to-Peer messaging that use external ports for short session-based <br>communication.")
	$table->set_td_option(-1, 0, "align=left colspan=2");
	$table->set_td_style(-1, 0, "font-family:verdana; color:#202020; font-size: 11px; padding:7 10 7 25", 2);


	$button = new BUTTON;
	$button->set_top_space("20");
	$button->set_locale($locale);
	$button->set_button (array($message->get_line(8)), array("{$form_name}_save()")); // 8 : ("Save")

	create_form($form);
	create_top_table_head();
	create_contents_table($table);
	create_button_table($button, "right");
	create_top_table_tail();
	create_html_tail();
?>
