<?
include ("/usr/local/www/include/cookie.h");
include ("/usr/local/www/include/function.h");
include ("/usr/local/www/include/htmltag.h");

$message = new MESSAGE;
$message->set_locale($locale);
$message->set_message("adsl_setting.msg");

$form_name = "adsl_setting";

$action = $_POST["action"];

$speed_DSL = $_POST["speed_DSL"];
$upstream = $_POST["upstream"];
$downstream = $_POST["downstream"];
$vc_channel = $_POST["vc_channel"];
$encapsulation = $_POST["encapsulation"];
$vpi = $_POST["vpi"];
$vci = $_POST["vci"];

$msg1 = $_POST["msg1"];
$msg2 = $_POST["msg2"];
$msg3 = $_POST["msg3"];
$msg4 = $_POST["msg4"];


$bin = new BIN;
$bin->set_service_type(2);
$bin->set_file_path();

$api = new CALLAPI;
$api->set_service_type("2");



if ($action == "save")
{

	$api->set_msg_id("13A");
	$api->set_record_size(10);
	$api->set_msg_length(10);
	$api->set_msg_type("F0");

	$value_input = NULL;
	$value_input[0] = $bin->num2str(dechex($upstream),2);
	$value_input[1] = $bin->num2str(dechex($downstream),2);
	$value_input[2] = $bin->num2str(dechex($speed_DSL),1);
	$value_input[3] = $bin->num2str(dechex($vc_channel),1);
	$value_input[4] = $bin->num2str(dechex($encapsulation),1);
	$value_input[5] = $bin->num2str(dechex($vpi),1);
	$value_input[6] = $bin->num2str(dechex($vci),1);
	$value_input[7] = NULL;

	$bin->set_structure(array(2,2,1,1,1,1,1,1));
	$ret = NULL;
	$ret = $bin->set_input_value(array($value_input));
	if ($ret)
	{
		$bin->writeBin();
		$api->exec_api();
		$resp = $bin->get_response();
		if (!$resp)
		{
			$tmp_msg = $message->get_line(23); // 23 : ("The data is not stored. Please check the input values.")
			$js_message = "alert(\"$tmp_msg\");\n";
		}
	}
	else
	{
		$tmp_msg = $message->get_line(1); // 1 ("Error")
		$js_message = "alert(\"$tmp_msg\");";
	}

}

if ($action == NULL)
{

	$api->set_msg_type("D0");
	$api->set_msg_id("13A");
	$api->set_record_size (10);
	$api->set_msg_length(0);
	$api->exec_api();
	$resp = $bin->get_response();
	if ($resp)
	{
		$ret = NULL;
		$bin->set_structure(array(2,2,1,1,1,1,1,1));

		$ret = $bin->readBin();
		if($ret)
		{
			$result = NULL;
			$result = $bin->get_result();
			$upstream = (int)$bin->str2num($result[0][0],2);
			$downstream = (int)$bin->str2num($result[0][1],2);
			$speed_DSL = (int)$bin->str2num($result[0][2],1);
			$vc_channel = (int)$bin->str2num($result[0][3],1);
			$encapsulation = (int)$bin->str2num($result[0][4],1);
			$vpi = (int)$bin->str2num($result[0][5],1);
			$vci = (int)$bin->str2num($result[0][6],1);
		}
		else
		{
			$tmp_msg = $message->get_line(1); // 1 : ("Error")
			$js_message = "alert(\"$tmp_msg\")";
		}
	}
	else
	{
		$tmp_msg = $message->get_line(24); // 24 : ("Failed to read data from system. Try again.")
		$js_message = "alert(\"$tmp_msg\")";
	}
	
}


//if (!$action)
{
	$msg1 = $message->get_line(17); // 17 : ("Please Input &quot;Upstream&quot;")
	$msg2 = $message->get_line(18); // 18 : ("Please Input &quot;Downstream&quot;")
	$msg3 = $message->get_line(20); // 20 : ("Please Input &quot;VPI&quot;")
	$msg4 = $message->get_line(21); // 21 : ("Please Input &quot;VCI&quot;")
}	

create_html_head();

?>

<script language=javascript>
<!--
<?
	if ($js_message != NULL)
	{
		echo "$js_message";
	}
?>	

function <? echo ($form_name) ?>_save()
{
	var vp = document.<? echo "$form_name" ?>.vpi;
	var vc = document.<? echo "$form_name" ?>.vci;
	var tmp_msg1 = document.<? echo "$form_name" ?>.msg1;
	var tmp_msg2 = document.<? echo "$form_name" ?>.msg2;
	var tmp_msg3 = document.<? echo "$form_name" ?>.msg3;
	var tmp_msg4 = document.<? echo "$form_name" ?>.msg4;
	
		if (vp.value.length == 0 || vp.value < 0 || vp.value > 255)
		{
			alert(tmp_msg3.value);
			vp.select();
			vp.focus();
			button_click=1;
			return false;
		}
		if (vc.value.length == 0 || vc.value < 0 || vc.value > 255)
		{
			alert(tmp_msg4.value);
			vc.select();
			vc.focus();
			button_click=1;
			return false;
		}
	document.<? echo "$form_name" ?>.action.value = 'save';
	document.<? echo "$form_name" ?>.submit();
}

function speed_dsl_option()
{
	var sel = document.<? echo "$form_name" ?>.speed_DSL.value;

	if (sel == 0)
	{
		document.<? echo "$form_name" ?>.upstream.disabled = true;
		document.<? echo "$form_name" ?>.downstream.disabled = true;

	}
	else if (sel == 1)
	{
		document.<? echo "$form_name" ?>.upstream.disabled = false;
		document.<? echo "$form_name" ?>.downstream.disabled = false;
	}
}

function vc_channel_conf()
{
	var sel = document.<? echo "$form_name" ?>.vc_channel.value;

	if (sel == 0)
	{
		document.<?echo "$form_name" ?>.encapsulation.disabled = true;
		document.<?echo "$form_name" ?>.vpi.disabled = true;
		document.<?echo "$form_name" ?>.vci.disabled = true;
	}
	else if (sel == 1)
	{
		document.<?echo "$form_name" ?>.encapsulation.disabled = false;
		document.<?echo "$form_name" ?>.vpi.disabled = false;
		document.<?echo "$form_name" ?>.vci.disabled = false;
	}
	
}

-->
</script>
<?

// form setting
	$form = new FORM;
	$form->set_name ("$form_name");
	$form->set_action($PHP_SELF);
	$form->add_hidden_input("action");
	$form->add_hidden_input("msg1", $msg1);
	$form->add_hidden_input("msg2", $msg2);
	$form->add_hidden_input("msg3", $msg3);
	$form->add_hidden_input("msg4", $msg4);
	

//  $auto_manual -> 2 : ("Auto"), 3 : ("Manual"));
    $auto_manual = array($message->get_line(2), "0", $message->get_line(3), "1");
//	$ecs -> 4 : ("LLC/SNAP"), 5 : ("VC Mux")
	$ecs = array($message->get_line(4), "0", $message->get_line(5), "1");


	$table = new TABLE;
	$table->set_title ($message->get_line(6)); // 6 : ("ADSL Setting")
	$table->set_top_space(1);
	$table->set_tr_option(0,"bgcolor=#FFFFFF");
	$table->set_top_width(array("100%"));
//	$table->set_top_contents(array($message->get_line(26)."<br>".$message->get_line(25))); // 26 : ("Basically, you don't need change below items."), 25 : ("Please check the seeting value with the supplier before you change these.")
	$table->set_top_contents(array($message->get_line(25)."<br>".$message->get_line(26))); // 25 : ("Please check the setting value with the supplier before you change these."), 26 : ("Basically, there is no need to change below items")
	$table->set_top_option(0,0, "style='font-family:verdana;font-size: 11px;padding:0 10 10 10;color:#7b7a7a'");
	$table->set_td_width(array("40%", "60%"));
		$tmp1 = create_html_number_input("vpi", "$vpi", $form_name, 3, "0~255", "style='width:90' $disabled0");
		$tmp2 = create_html_number_input("vci", "$vci", $form_name, 3, "0~255", "style='width:90' $disabled0");
		$tmp3 = create_html_select("encapsulation", $ecs, $encapsulation, "style='width:90' $disabled0", 2); 
	$table->add_tr_contents(array($message->get_line(14), $tmp3)); // 14 : ("Encapsulation")
	$table->set_td_option(-1,0,"align=left");
	$table->set_td_style(-1, 0, NULL, 1);
	$table->set_td_option(-1, 1, "align=left");
	$table->set_td_style(-1, 1, NULL);
	$table->add_tr_contents(array($message->get_line(15), $tmp1)); // 15 : ("VPI")
	$table->set_td_option(-1,0,"align=left");
	$table->set_td_style(-1, 0, NULL, 1);
	$table->set_td_option(-1, 1, "align=left");
	$table->set_td_style(-1, 1, NULL);
	$table->add_tr_contents(array($message->get_line(16), $tmp2)); // 16 : ("VCI")
	$table->set_td_option(-1,0,"align=left");
	$table->set_td_style(-1, 0, NULL, 1);
	$table->set_td_option(-1, 1, "align=left");
	$table->set_td_style(-1, 1, NULL);
	
				

	$button = new BUTTON;
	$button->set_top_space("20");
	$button->set_locale($locale);
	$button->set_button (array($message->get_line(27)), array("{$form_name}_save()")); // 27 : ("Save")

	create_form($form);
	create_top_table_head();
	create_contents_table($table);
	create_button_table($button, "right");
	create_top_table_tail();
	create_html_tail();

?>




	
	
